=== external/radler/doc/requirements.txt ===
# SPDX-License-Identifier: LGPL-3.0-only

# Required python packages for building on ReadTheDocs.
# See .readthedocs.yaml in the root of this repository.
breathe
myst-parser
numpy
