=== debian/changelog ===
wsclean (3.4-3build3) plucky; urgency=medium

  * No-change rebuild against libhdf5-310

 -- Miriam España Acebal <miriam.espana@canonical.com>  Sun, 26 Jan 2025 11:10:22 +0000

wsclean (3.4-3build2) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 04 Jan 2025 05:19:01 +0100

wsclean (3.4-3build1) plucky; urgency=medium

  * No-change rebuild for libcasa-casa8

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 01 Nov 2024 08:06:50 +0000

wsclean (3.4-3) unstable; urgency=medium

  * Fix missing include required for gcc14 in wgridder (Closes: #1075643)

 -- Ole Streicher <olebole@debian.org>  Tue, 30 Jul 2024 18:21:10 +0200

wsclean (3.4-2) unstable; urgency=medium

  * Link Radler a static instead of shared library. Closes: #1070237
  * Push Standards-Version to 4.7.0. No changes needed
  * Add superficial autopkgtest

 -- Ole Streicher <olebole@debian.org>  Sat, 18 May 2024 17:35:57 +0200

wsclean (3.4-1) unstable; urgency=medium

  * New upstream version 3.4
  * Rediff patches. Drop fix-gcc-13.patch: applied upstream
  * Mark libradler shared lib as not installed

 -- Ole Streicher <olebole@debian.org>  Thu, 26 Oct 2023 12:50:06 +0200

wsclean (3.1-4) unstable; urgency=medium

  * Team upload.
  * Add fix-gcc-13.patch to fix gcc-13 build issues. (Closes: #1037899)

 -- Bo YU <tsu.yubo@gmail.com>  Wed, 26 Jul 2023 16:43:38 +0800
